       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CBLTRXC1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: CBLTRXC1.CBL
      * Copy Files:    PASSBITS.CPY
      * Calls to:      SIMOBITS
      *****************************************************************
      *
      * CBLTRXC1 - COBOL code for commonly used processing tasks.
      *
      * CALLING PROTOCOL
      * ----------------
      * Use standard procedure to RUN or ANIMATE.
      *
      * DESCRIPTION
      * -----------
      * This program shows how to to some common business or system
      * tasks. This program will also call a COBOL routine to access
      * and sort a table..
      *
      *  ************                    ************
      *  *  Entry   *                    *  Entry   *
      *  *   MVS    *                    * Windows  *
      *  ************                    ************
      *       *                               *
      *  ************                    ************
      *  * CBLTRXJ1 *                    * CBLTRXE1 *
      *  ********jcl*                    ********cmd*
      *       *                               *
      *  ************                         *
      *  * IEFBR14  *                         *
      *  ********utl*                         *
      *       *                               *
      *       *********************************
      *                       *
      *                       *
      *                  ************    ************
      *                  * CBLTRXC1 *----* DISPLAY  *
      *                  ********cbl*    ************
      *                    *      *
      *                    *      *
      *                    *      *
      *       **************      *---CALL----*
      *       *                               *
      *       *                               *
      *  ************                         *
      *  *   EOJ    *                         *
      *  ************                         *
      *                                       *
      *                                       *
      *                                       *
      *                  ************    ************    ************
      *                  * TXTA0512 *----* CBLTBLC1 *----* LABEL1X6 *
      *                  ********txt*    ********cbl*    ********txt*
      *
      *
      * This program calls CBLTBLC1 to process a table.
      *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1989/02/27 Simmons, Created program.
      * 1997/03/17 Simmons, Updated for call to SIMOBITS.
      *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    -----------------------------------------------------------*
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CBLTRXC1 '.
           05  T2 pic X(34) value 'Techniques and Common Routines'    .
           05  T3 pic X(10) value ' v11.11.03'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CBLTRXC1 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* CBLTRXC1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* CBLTRXC1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

      *****************************************************************
      *    Buffer used for posting messages to the console.
      *    -----------------------------------------------------------*
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CBLTRXC1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(41)   value SPACES.
      *    End-of-Message-Buffer

       01  TASK-FLAGS.
           05  TASK-FLAG-BANNER    pic X       value 'Y'.
           05  TASK-FLAG-THANKS    pic X       value 'Y'.
           05  TASK-FLAG-DISPLAY   pic X       value 'Y'.
           05  TASK-FLAG-SYSOUT    pic X       value 'Y'.

       01  WORK-50                 pic X(50)   value SPACES.
       01  IX-1                    pic 9(3)    value 0.

       01  BASE-FIELD              pic X(3)    value 'ABC'.
       01  BASE-FIELD-X            redefines   BASE-FIELD.
           05  BASE-FIELD-X1       pic X.
           05  BASE-FIELD-X2       pic X.
           05  BASE-FIELD-X3       pic X.

       01  NUMBERS-GROUP-01.
           05  NBR-05-PACK-SIGN        pic S9(5)   comp-3 value 123.
           05  NBR-05-PACK-SIGN-X      redefines   NBR-05-PACK-SIGN
                                       pic X(3).
           05  FILLER                  pic X(13)   value SPACES.

           05  NBR-05-SIGN-LEAD-S      pic S9(5)   value 456
                                       SIGN LEADING SEPARATE.
           05  NBR-05-SIGN-LEAD-S-X    redefines   NBR-05-SIGN-LEAD-S
                                       pic X(6).
           05  FILLER                  pic X(10)   value SPACES.

           05  NBR-05-EDIT-SIGN        pic +ZZZ.99.
           05  FILLER                  pic X(09)   value SPACES.


       01  NBR-12-X                pic X(12)   value '123'.
       01  NBR-12                  redefines   NBR-12-X
                                   pic 9(12).

       01  ROUTINE-NAME            pic X(31).
       01  WORK-80                 pic X(80).

       01  UPPER-CASE  pic X(26) value 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.
       01  LOWER-CASE  pic X(26) value 'abcdefghijklmnopqrstuvwxyz'.

       01  MONTH-DATA.
           05  FILLER      pic X(9)    value 'January  '.
           05  FILLER      pic X(9)    value 'February '.
           05  FILLER      pic X(9)    value 'March    '.
           05  FILLER      pic X(9)    value 'April    '.
           05  FILLER      pic X(9)    value 'May      '.
           05  FILLER      pic X(9)    value 'June     '.
           05  FILLER      pic X(9)    value 'July     '.
           05  FILLER      pic X(9)    value 'August   '.
           05  FILLER      pic X(9)    value 'September'.
           05  FILLER      pic X(9)    value 'October  '.
           05  FILLER      pic X(9)    value 'November '.
           05  FILLER      pic X(9)    value 'December '.
       01  MONTH-TABLE     redefines   MONTH-DATA.
           05  MONTH-TEXT  pic X(9)    occurs 12 times.
       01  MM-IDX          pic 99      value 0.

       01  TODAY-IN-TEXT.
           05  FILLER      pic X(9)    value 'Today is '.
           05  TODAY-WORD  pic X(18)   value SPACES.
      *****************************************************************
      *    Working Storage items for the Z-ROUTINES...
      *    -----------------------------------------------------------*
       01  Z-DATE-01.
           05  Z-DATE-01-CC   pic 9(02).
           05  Z-DATE-01-YY   pic 9(02).
           05  Z-DATE-01-MM   pic 9(02).
           05  Z-DATE-01-DD   pic 9(02).
       01  Z-TIME-01.
           05  Z-TIME-01-HH   pic X(02).
           05  Z-TIME-01-NN   pic X(02).
           05  Z-TIME-01-SS   pic X(02).
           05  Z-TIME-01-TT   pic X(02).

       01  Z-DATE-TIME-02.
           05  Z-DATE-02.
               10  Z-DATE-02-CC   pic 9(02).
               10  Z-DATE-02-YY   pic 9(02).
               10  FILLER         pic X        value '/'.
               10  Z-DATE-02-MM   pic 9(02).
               10  FILLER         pic X        value '/'.
               10  Z-DATE-02-DD   pic 9(02).
           05  filler             pic x(3)     value ' - '.
           05  Z-TIME-02.
               10  Z-TIME-02-HH   pic 9(02).
               10  FILLER         pic X        value ':'.
               10  Z-TIME-02-MM   pic 9(02).
               10  FILLER         pic X        value ':'.
               10  Z-TIME-02-SS   pic 9(02).
               10  FILLER         pic X        value '.'.
               10  Z-TIME-02-TT   pic 9(02).

       01  Z-DATE-TIME-03.
           05  Z-DATE-03.
               10  Z-DATE-03-CC   pic 9(02).
               10  Z-DATE-03-YY   pic 9(02).
               10  FILLER         pic X        value '/'.
               10  Z-DATE-03-MM   pic 9(02).
               10  FILLER         pic X        value '/'.
               10  Z-DATE-03-DD   pic 9(02).
           05  filler             pic x(3)     value ' - '.
           05  Z-TIME-03.
               10  Z-TIME-03-HH   pic 9(02).
               10  FILLER         pic X        value ':'.
               10  Z-TIME-03-MM   pic 9(02).
               10  FILLER         pic X        value ':'.
               10  Z-TIME-03-SS   pic 9(02).
               10  FILLER         pic X        value '.'.
               10  Z-TIME-03-TT   pic 9(02).

       01  ELASPED-TIME-X.
           05  ELAPSED-TIME       pic ZZ,ZZZ.99.

       01  INITIALIZE-GROUP.
           05  INIT-TEXT-01       pic X(6)           value 'PREFIX'.
           05  INIT-ZDU1-01       pic 9(5)           value 12345.
           05  INIT-PDU1-01       pic 9(5)   COMP-3  value 12345.
           05  INIT-BNU1-01       pic 9(5)   COMP    value 12345.
           05  INIT-TEXT-02       pic X(6)           value 'SUFFIX'.
       01  INITIAL-TOTAL          pic 9(7)           value 0.

       01  Z-WORK-12              pic X(12)   value SPACES.
       01  Z-X12                  pic 9(3)    value 0.

       01  DUMP-HEADER.
           05  filler pic X value '*'.
           05  filler pic X value ' '.
           05  H1 pic X(7)  value ' Offset'.
           05  filler pic X value ' '.
           05  H2 pic X(35) value 'Hex..... ........ ........ ........'.
           05  filler pic X value ' '.
           05  H3 pic X(16) value 'ebcdic..........'.
           05  filler pic X value ' '.
           05  H4 pic X(16) value 'ascii...........'.

       COPY PASSDUMP.
       COPY ASCEBCB1.

      *****************************************************************
       PROCEDURE DIVISION.

           if  TASK-FLAG-BANNER = 'Y'
               perform Z-POST-COPYRIGHT
           end-if

      *    Show an example of accessing the system date and time.
           perform GET-SYSTEM-DATE

      *    Show how to use the INSPECT statement to do case conversion.
           perform CASE-CONVERSION

      *    Show how to convert between ASCII and EBCDIC using the
      *    INSPECT statement.
           perform ASCII-EBCDIC-CONVERSION

      *    Show an example of a COBOL REDEFINES
           perform COBOL-REDEFINES-EXAMPLE

           perform COBOL-REFERENCE-MODIFICATION

      *    Show how to test for a numeric value within a field.
           perform NUMERIC-TESTING

      *    Show a Right-Adjust and Zero-fill.
           perform RIGHT-ADJUST-ZERO-FILL

      *    Show how to convert from a NUMERIC, PACKED field to a
      *    display, numeric field.
           perform NUMERIC-PACKED-TO-DISPLAY

      *    Show an example of table processing
           perform TABLE-PROCESSING-BUBBLE-SORT

           perform Z-GET-DATE-AND-TIME

           if  TASK-FLAG-THANKS = 'Y'
               perform Z-THANK-YOU
           end-if

           GOBACK.

      * HTML-TAG                   <A NAME="AsciiEbcdicConversion"></A> SIMOHTML
      *****************************************************************
       ASCII-EBCDIC-CONVERSION.
           move 'ASCII-EBCDIC-CONVERSION' to ROUTINE-NAME
           perform Z-ROUTINE-STARTING

           perform Z-ROUTINE-FINISHED
           exit.

      * HTML-TAG                    <A NAME="CalculateElapsedTime"></A> SIMOHTML
      *****************************************************************
      * This routine requires the following items.
      *      Z-DATE-TIME-02 will contain the stop time
      *      Z-DATE-TIME-03 will contain the start time
      * This routine will provide the follow item.
      *      ELAPSED-TIME   will be calculated by the sub-routine.
      *
       CALCULATE-ELAPSED-TIME.
           if  Z-DATE-TIME-02 > Z-DATE-TIME-03
               compute
                   ELAPSED-TIME = (Z-TIME-02-HH * 3600
                                   + Z-TIME-02-MM * 60
                                   + Z-TIME-02-SS
                                   + Z-TIME-02-TT / 100)
                                -
                                  (Z-TIME-03-HH * 3600
                                   + Z-TIME-03-MM * 60
                                   + Z-TIME-03-SS
                                   + Z-TIME-03-TT / 100)
           else
               move ZEROES to ELAPSED-TIME
           end-if
           exit.

      * HTML-TAG                          <A NAME="CaseConversion"></A> SIMOHTML
      *****************************************************************
      * This routine will convert text strings of mixed case to all
      * upper or lower case.
      *
       CASE-CONVERSION.
           move 'CASE-CONVERSION' to ROUTINE-NAME
           perform Z-ROUTINE-STARTING

           move 'Before - Please make this all upper case'
             to MESSAGE-TEXT
           perform Z-POST-MESSAGE
           move 'After  - Please make this all upper case'
             to MESSAGE-TEXT
      *    Do the case conversion . . .
           inspect MESSAGE-TEXT converting LOWER-CASE to UPPER-CASE
           perform Z-POST-MESSAGE

           move 'BEFORE - PLEASE MAKE THIS ALL LOWER CASE'
             to MESSAGE-TEXT
           perform Z-POST-MESSAGE
           move 'AFTER  - PLEASE MAKE THIS ALL LOWER CASE'
             to MESSAGE-TEXT
      *    Do the case conversion . . .
           inspect MESSAGE-TEXT converting UPPER-CASE to LOWER-CASE
           perform Z-POST-MESSAGE

           perform Z-ROUTINE-FINISHED
           exit.

      * HTML-TAG                   <A NAME="CobolRedefinesExample"></A> SIMOHTML
      *****************************************************************
       COBOL-REDEFINES-EXAMPLE.
           move 'COBOL-REDEFINES-EXAMPLE' to ROUTINE-NAME
           perform Z-ROUTINE-STARTING

      *    Display the full three (3) byte field
           move 'Base-Field    ' to MESSAGE-TEXT
           move BASE-FIELD       to MESSAGE-TEXT(17:3)
           perform Z-POST-MESSAGE
      *    Display the 1st byte of the field using the REDEFINE
           move 'Base-Field-X1 ' to MESSAGE-TEXT
           move BASE-FIELD-X1    to MESSAGE-TEXT(17:1)
           perform Z-POST-MESSAGE
      *    Display the 2nd byte of the field using the REDEFINE
           move 'Base-Field-X2 ' to MESSAGE-TEXT
           move BASE-FIELD-X2    to MESSAGE-TEXT(17:1)
           perform Z-POST-MESSAGE
      *    Display the 3rd byte of the field using the REDEFINE
           move 'Base-Field-X3 ' to MESSAGE-TEXT
           move BASE-FIELD-X3    to MESSAGE-TEXT(17:1)
           perform Z-POST-MESSAGE

           perform Z-ROUTINE-FINISHED
           exit.

      * HTML-TAG              <A NAME="CobolReferenceModification"></A> SIMOHTML
      *****************************************************************
       COBOL-REFERENCE-MODIFICATION.
           move 'COBOL-REFERENCE-MODIFICATION' to ROUTINE-NAME
           perform Z-ROUTINE-STARTING

           move 'Access each byte in a text string, Explicit Code'
           to MESSAGE-TEXT
           perform Z-POST-MESSAGE
      *    Display the full three (3) byte field
           move 'Base-Field      ' to MESSAGE-TEXT
           move BASE-FIELD         to MESSAGE-TEXT(17:3)
           perform Z-POST-MESSAGE
      *    Reference and display the 1st byte of the field
           move 'Base-Field(1:1) ' to MESSAGE-TEXT
           move BASE-FIELD(1:1)    to MESSAGE-TEXT(17:1)
           perform Z-POST-MESSAGE
      *    Reference and display the 2nd byte of the field
           move 'Base-Field(2:1) ' to MESSAGE-TEXT
           move BASE-FIELD(2:1)    to MESSAGE-TEXT(17:1)
           perform Z-POST-MESSAGE
      *    Reference and display the 3rd byte of the field
           move 'Base-Field(3:1) ' to MESSAGE-TEXT
           move BASE-FIELD(3:1)    to MESSAGE-TEXT(17:1)
           perform Z-POST-MESSAGE

           move 'Access each byte in a text string, Perform loop'
           to MESSAGE-TEXT
           perform Z-POST-MESSAGE
      *    Display the full three (3) byte field
           move 'Text String     ' to MESSAGE-TEXT
           move UPPER-CASE         to MESSAGE-TEXT(17:26)
           perform Z-POST-MESSAGE
      *    Reference and display each byte of the field
           perform varying IX-1 from 1 by 1 until IX-1 > 26
               move 'Byte nnn is the character ' to MESSAGE-TEXT
               inspect MESSAGE-TEXT replacing first 'nnn' by IX-1
               move UPPER-CASE(IX-1:1) to MESSAGE-TEXT(27:1)
               perform Z-POST-MESSAGE
           end-perform

           perform Z-ROUTINE-FINISHED
           exit.

      * HTML-TAG                           <A NAME="GetSystemDate"></A> SIMOHTML
      *****************************************************************
       GET-SYSTEM-DATE.
           move 'GET-SYSTEM-DATE' to ROUTINE-NAME
           perform Z-ROUTINE-STARTING

           perform Z-GET-DATE-AND-TIME

           move Z-DATE-01            to MESSAGE-TEXT
           move 'System Date   ' to MESSAGE-TEXT(14:14)
           perform Z-POST-MESSAGE
           move Z-TIME-01            to MESSAGE-TEXT
           move 'System Time   ' to MESSAGE-TEXT(14:14)
           perform Z-POST-MESSAGE

           move Z-DATE-02            to MESSAGE-TEXT
           move 'Formatted Date' to MESSAGE-TEXT(14:14)
           perform Z-POST-MESSAGE
           move Z-TIME-02            to MESSAGE-TEXT
           move 'Formatted Time' to MESSAGE-TEXT(14:14)
           perform Z-POST-MESSAGE

           if  Z-DATE-01-MM GREATER THAN 0
           and                 LESS THAN 13
               move MONTH-TEXT(Z-DATE-01-MM) to TODAY-WORD
               inspect TODAY-WORD replacing all SPACES by '*'
               inspect TODAY-WORD replacing first '**' by ' *'
               inspect TODAY-WORD replacing first '**' by Z-DATE-01-DD
               inspect TODAY-WORD replacing first '**' by ', '
               inspect TODAY-WORD replacing first '**' by Z-DATE-01-CC
               inspect TODAY-WORD replacing first '**' by Z-DATE-01-YY
               inspect TODAY-WORD replacing all '*' by SPACES
               move TODAY-IN-TEXT to MESSAGE-TEXT
               perform Z-POST-MESSAGE
           else
               move 'INVALID Month requested...' to MESSAGE-TEXT
               perform Z-POST-MESSAGE
           end-if
           perform Z-ROUTINE-FINISHED
           exit.

      * HTML-TAG                  <A NAME="NumericPackedToDisplay"></A> SIMOHTML
      *****************************************************************
       NUMERIC-PACKED-TO-DISPLAY.
           move 'NUMERIC-PACKED-TO-DISPLAY' to ROUTINE-NAME
           perform Z-ROUTINE-STARTING

      *    The following statement will place the arithmetic value of
      *    the packed-decimal field into the zone-decimal field with
      *    the SIGN LEADING SEPARATE.
      *    The actual value will be x'4EF0F0F1F2F3'. This results in
      *    converting the packed-decimal field. Both fields have an
      *    implied decimal point.
           add NBR-05-PACK-SIGN to ZERO giving NBR-05-SIGN-LEAD-S

      *    The following statement will place the arithmetic value of
      *    the packed-decimal field into the edited print field. The
      *    actual value will be x'4E4040F14BF2F3'. This results in
      *    converting the packed-decimal field but has leading spaces.
           add NBR-05-PACK-SIGN to ZERO giving NBR-05-EDIT-SIGN

      *    The preceding two (2) statements do the conversion of the
      *    packed-decimal field to a display-text field.
      *    The following will post a hexadecimal dump of the various
      *    fields with the possible ASCII or EBCDIC display.
      *    The hexadecimal dump information is posted to both the
      *    SYSOUT and SYSLOG files.

           move 'DUMP' to SIMODUMP-REQUEST
           move 'HIDE' to SIMODUMP-COPYRIGHT
           if  TASK-FLAG-SYSOUT = 'Y'
               move 'LOG1' to SIMODUMP-OUTPUT
           else
               move 'OPR2' to SIMODUMP-OUTPUT
           end-if
           move 'PACKED01' to SIMODUMP-DUMP-ID
           add length of NUMBERS-GROUP-01
                      to             ZERO
                  giving  SIMODUMP-LENGTH
           move NUMBERS-GROUP-01 to SIMODUMP-BUFFER
           call 'SIMODUMP' using SIMODUMP-PASS-AREA
                                 SIMODUMP-BUFFER
           move 'Info_MSG Display Working Storage dump' to MESSAGE-TEXT
           perform Z-POST-MESSAGE
           move DUMP-HEADER to MESSAGE-TEXT
           perform Z-POST-MESSAGE
           move SIMODUMP-LINES(1) to MESSAGE-TEXT
           perform Z-POST-MESSAGE
           move SIMODUMP-LINES(2) to MESSAGE-TEXT
           perform Z-POST-MESSAGE
           move SIMODUMP-LINES(3) to MESSAGE-TEXT
           perform Z-POST-MESSAGE

           perform Z-ROUTINE-FINISHED
           exit.

      * HTML-TAG                          <A NAME="NumericTesting"></A> SIMOHTML
      *****************************************************************
       NUMERIC-TESTING.
      *    This segment of code will describe and demonstrate the
      *    COBOL techniques for checking the validity of a numeric
      *    field. The techniques for initializing both numeric and
      *    alphanumeric fields is included.
      *
      *    Data Structure used for this example is as follows:
      *
      *01  INITIALIZE-GROUP.
      *    05  INIT-TEXT-01       pic X(6)           value 'PREFIX'.
      *    05  INIT-ZDU1-01       pic 9(5)           value 12345.
      *    05  INIT-PDU1-01       pic 9(5)   COMP-3  value 12345.
      *    05  INIT-BNU1-01       pic 9(5)   COMP    value 12345.
      *    05  INIT-TEXT-02       pic X(6)           value 'SUFFIX'.
      *01  INITIAL-TOTAL          pic 9(7)           value 0.
      *
           move 'NUMERIC-TESTING' to ROUTINE-NAME
           perform Z-ROUTINE-STARTING
      *---------------------------------------------------------------*
      *    T1, Test the program default values of the group numerics
      *    for validity and display results.
      *
           if  INIT-ZDU1-01 is NUMERIC
           and INIT-PDU1-01 is NUMERIC
               compute INITIAL-TOTAL = INIT-ZDU1-01
                                     + INIT-PDU1-01
                                     + INIT-BNU1-01
               display '* CBLTRXC1 T1, INIT-TEXT-01 is ' INIT-TEXT-01
               display '* CBLTRXC1 T1, INITIAL-TOTAL = ' INITIAL-TOTAL
               display '* CBLTRXC1 T1, INIT-TEXT-02 is ' INIT-TEXT-02
           else
               move 'T1, A Numeric Field contains non-Numeric value...'
                 to MESSAGE-TEXT
               perform Z-POST-MESSAGE
           end-if

      *---------------------------------------------------------------*
      *    T2, Initialize the fields as a group. This should initialize
      *        the text strings to spaces and the numerics to Zeroes.
      *        Test the numerics for validity and display results.
      *
           initialize INITIALIZE-GROUP
           if  INIT-ZDU1-01 is NUMERIC
           and INIT-PDU1-01 is NUMERIC
               compute INITIAL-TOTAL = INIT-ZDU1-01
                                     + INIT-PDU1-01
                                     + INIT-BNU1-01
               display '* CBLTRXC1 T2, INIT-TEXT-01 is ' INIT-TEXT-01
               display '* CBLTRXC1 T2, INITIAL-TOTAL = ' INITIAL-TOTAL
               display '* CBLTRXC1 T2, INIT-TEXT-02 is ' INIT-TEXT-02
           else
               move 'T2, A Numeric Field contains non-Numeric value...'
                 to MESSAGE-TEXT
               perform Z-POST-MESSAGE
           end-if

      *---------------------------------------------------------------*
      *    T3, Initialize the fields as a group using the "replacing"
      *        function of the INITIALIZE. The following segment of
      *        code should initialize the text strings to all X's and
      *        the numerics to 1.
      *        Test the numerics for validity and display results.
      *
           initialize INITIALIZE-GROUP replacing
                                       NUMERIC DATA by 1
                                       ALPHANUMERIC BY all 'X'
           if  INIT-ZDU1-01 is NUMERIC
           and INIT-PDU1-01 is NUMERIC
               compute INITIAL-TOTAL = INIT-ZDU1-01
                                     + INIT-PDU1-01
                                     + INIT-BNU1-01
               display '* CBLTRXC1 T3, INIT-TEXT-01 is ' INIT-TEXT-01
               display '* CBLTRXC1 T3, INITIAL-TOTAL = ' INITIAL-TOTAL
               display '* CBLTRXC1 T3, INIT-TEXT-02 is ' INIT-TEXT-02
           else
               move 'T3, A Numeric Field contains non-Numeric value...'
                 to MESSAGE-TEXT
               perform Z-POST-MESSAGE
           end-if

      *---------------------------------------------------------------*
      *    T4, Move all spaces to the group item. The following
      *        segment of code should move all spaces to all the fields
      *        under the group item. This should produce an invalid
      *        result when the numeric fields are tested for validity.
      *
      *        The use of a "MOVE" of all SPACES at the group level is
      *        not a good practice when the group contains fields that
      *        are defined as numeric.
      *
           move all SPACES to INITIALIZE-GROUP
           if  INIT-ZDU1-01 is NUMERIC
           and INIT-PDU1-01 is NUMERIC
               compute INITIAL-TOTAL = INIT-ZDU1-01
                                     + INIT-PDU1-01
                                     + INIT-BNU1-01
               display '* CBLTRXC1 T4, INIT-TEXT-01 is ' INIT-TEXT-01
               display '* CBLTRXC1 T4, INITIAL-TOTAL = ' INITIAL-TOTAL
               display '* CBLTRXC1 T4, INIT-TEXT-02 is ' INIT-TEXT-02
           else
               move 'T4, A Numeric Field contains non-Numeric value...'
                 to MESSAGE-TEXT
               perform Z-POST-MESSAGE
           end-if

           perform Z-ROUTINE-FINISHED
           exit.

      * HTML-TAG                     <A NAME="RightAdjustZeroFill"></A> SIMOHTML
      *****************************************************************
      *
       RIGHT-ADJUST-ZERO-FILL.
           move 'RIGHT-ADJUST-ZERO-FILL' to ROUTINE-NAME
           perform Z-ROUTINE-STARTING

           move '123         ' to NBR-12-X
           perform RIGHT-ADJUST-ZERO-FILL-02

           move '12345       ' to NBR-12-X
           perform RIGHT-ADJUST-ZERO-FILL-02

           move '1234567     ' to NBR-12-X
           perform RIGHT-ADJUST-ZERO-FILL-02

           perform Z-ROUTINE-FINISHED
           exit.
      *---------------------------------------------------------------*
       RIGHT-ADJUST-ZERO-FILL-02.
      *    Test for Numeric content before the Right-Adjust, leading,
      *    trailing or embedded space characters should cause a
      *    non-numeric condition to exist.
           if  NBR-12 NUMERIC
               move 'NBR-12 AOK...' to MESSAGE-TEXT
               move NBR-12           to MESSAGE-TEXT(14:12)
               perform Z-POST-MESSAGE
           else
               move 'NBR-12 NOK...' to MESSAGE-TEXT
               move NBR-12           to MESSAGE-TEXT(14:12)
               perform Z-POST-MESSAGE
           end-if

      *    Do the Right-Adjust with Zero-Fill
           move NBR-12-X to Z-WORK-12
           perform Z-RIGHT-ADJUST-Z-WORK-12
           move Z-WORK-12 to NBR-12-X

      *    Test for Numeric content after the Right-Adjust
           if  NBR-12 NUMERIC
               move 'NBR-12 AOK...' to MESSAGE-TEXT
               move NBR-12           to MESSAGE-TEXT(14:12)
               perform Z-POST-MESSAGE
           else
               move 'NBR-12 NOK...' to MESSAGE-TEXT
               move NBR-12           to MESSAGE-TEXT(14:12)
               perform Z-POST-MESSAGE
           end-if
           exit.

      * HTML-TAG                         <A NAME="TableProcessing"></A> SIMOHTML
      *****************************************************************
      *
       TABLE-PROCESSING-BUBBLE-SORT.
           move 'TABLE-PROCESSING-BUBBLE-SORT' to ROUTINE-NAME
           perform Z-ROUTINE-STARTING
      *    Get and Post the Starting Time
           perform Z-GET-DATE-AND-TIME
           move Z-DATE-TIME-02 to Z-DATE-TIME-03
           move 'Starting Time ' to MESSAGE-TEXT
           move Z-DATE-TIME-03   to MESSAGE-TEXT(15:24)
           perform Z-POST-MESSAGE

           call 'CBLTBLC1'

      *    Get and Post the Finished Time
           perform Z-GET-DATE-AND-TIME
           move 'Finished Time ' to MESSAGE-TEXT
           move Z-DATE-TIME-02   to MESSAGE-TEXT(15:24)
           perform Z-POST-MESSAGE

           perform CALCULATE-ELAPSED-TIME

           move 'Elapsed Time ' to MESSAGE-TEXT
           move ELAPSED-TIME    to MESSAGE-TEXT(30:9)
           move 'Seconds'       to MESSAGE-TEXT(40:7)
           perform Z-POST-MESSAGE

           perform Z-ROUTINE-FINISHED
           exit.

      * HTML-TAG                         <A NAME="zGetDateAndTime"></A> SIMOHTML
      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************
      * This routine requires COBOL for 390 dialect because of the
      * use of the YYYYMMDD on the ACCEPT statement.
      *
       Z-GET-DATE-AND-TIME.
           accept Z-DATE-01 from DATE YYYYMMDD
           accept Z-TIME-01 from TIME

           move 'ccyy/mm/dd'   to Z-DATE-02
           move Z-DATE-01(1:4) to Z-DATE-02(1:4)
           move Z-DATE-01(5:2) to Z-DATE-02(6:2)
           move Z-DATE-01(7:2) to Z-DATE-02(9:2)

           move 'hh:mm:ss.00'  to Z-TIME-02
           move Z-TIME-01(1:2) to Z-TIME-02(1:2)
           move Z-TIME-01(3:2) to Z-TIME-02(4:2)
           move Z-TIME-01(5:2) to Z-TIME-02(7:2)
           move Z-TIME-01(7:2) to Z-TIME-02(10:2)

           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           if  TASK-FLAG-SYSOUT = 'Y'
               display SIM-TITLE
               display SIM-COPYRIGHT
           else
               display SIM-TITLE     upon console
               display SIM-COPYRIGHT upon console
           end-if
           exit.

      *****************************************************************
       Z-POST-MESSAGE.
           if  TASK-FLAG-SYSOUT = 'Y'
               display MESSAGE-BUFFER
           else
               display MESSAGE-BUFFER upon console
           end-if
           move SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
       Z-POST-MESSAGE-TEXT.
           if  MESSAGE-TEXT-2 = SPACES
               if  TASK-FLAG-SYSOUT = 'Y'
                   display MESSAGE-BUFFER(1:79)
               else
                   display MESSAGE-BUFFER(1:79) upon console
               end-if
           else
               if  TASK-FLAG-SYSOUT = 'Y'
                   display MESSAGE-BUFFER
               else
                   display MESSAGE-BUFFER upon console
               end-if
           end-if
           move SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Delete all characters to the right of the first space then
      * right-adjust with zero fill. This routine works with a single,
      * twelve character field and does not require a work area.
      *****************************************************************
       Z-RIGHT-ADJUST-Z-WORK-12.
      *    The following INSPECT statement will erase to end-of-field
      *    any characters after the first space character.
           inspect Z-WORK-12
                   replacing CHARACTERS by ' ' after initial ' '

      *    The following IF logic is for performance. It quickly
      *    reduces the number of loops for the PERFORM logic.
           if  Z-WORK-12(7:6) = SPACES
               if  Z-WORK-12(4:3) = SPACES
                   move Z-WORK-12(1:3) to Z-WORK-12(10:3)
                   move all ZEROES     to Z-WORK-12(1:9)
               else
                   move Z-WORK-12(1:6) to Z-WORK-12(7:6)
                   move all ZEROES     to Z-WORK-12(1:6)
               end-if
           else
               if  Z-WORK-12(10:3) = SPACES
      *            The following three MOVE statements are used to
      *            avoid a potential problem with an overlapping MOVE.
                   move Z-WORK-12(7:3) to Z-WORK-12(10:3)
                   move Z-WORK-12(4:3) to Z-WORK-12(7:3)
                   move Z-WORK-12(1:3) to Z-WORK-12(4:3)
                   move all ZEROES     to Z-WORK-12(1:3)
               end-if
           end-if

           perform until Z-WORK-12(12:1) not = SPACE
               if  Z-WORK-12(12:1) = SPACE
                   add 11 to ZERO giving Z-X12
                   perform 11 times
                     move Z-WORK-12(Z-X12:1) to Z-WORK-12(Z-X12 + 1:1)
                     subtract 1 from Z-X12
                   end-perform
                   move ZERO to Z-WORK-12(1:1)
               end-if
           end-perform
           exit.

      *****************************************************************
       Z-ROUTINE-STARTING.
           if  TASK-FLAG-DISPLAY = 'Y'
               move all '-' to MESSAGE-TEXT(1:64)
               move     '*' to MESSAGE-TEXT(1:1)
               move     '*' to MESSAGE-TEXT(64:1)
               perform Z-POST-MESSAGE-TEXT
               move 'Starting ' to MESSAGE-TEXT
               move ROUTINE-NAME to MESSAGE-TEXT(10:32)
               perform Z-POST-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-ROUTINE-FINISHED.
           if  TASK-FLAG-DISPLAY = 'Y'
               move 'Finished ' to MESSAGE-TEXT
               move ROUTINE-NAME to MESSAGE-TEXT(10:32)
               perform Z-POST-MESSAGE-TEXT
               move SPACES to ROUTINE-NAME
           end-if
           exit.

      *****************************************************************
       Z-THANK-YOU.
           if  TASK-FLAG-SYSOUT = 'Y'
               display SIM-THANKS-01
               display SIM-THANKS-02
           else
               display SIM-THANKS-01 upon console
               display SIM-THANKS-02 upon console
           end-if
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
